;*************************************************************************
;*									 *
;*				Generic AVR Bootloader			 *
;*                                                                       *
;*                      Author: Peter Dannegger                          *
;*									 *
;*************************************************************************
.nolist
;			select the appropriate include file:
;.include "tn13def.inc"
;.include "tn2313def.inc"
;.include "tn25def.inc"
;.include "tn261def.inc"
;.include "tn44def.inc"
;.include "tn45def.inc"
;.include "tn461def.inc"
;.include "m48def.inc"
;.include "tn84def.inc"
;.include "tn85def.inc"
;.include "tn861def.inc"

;			set the SecondBootStart fuse on these AVRs:
;.include "m8def.inc"
;.include "m8515def.inc"
;.include "m8535def.inc"
;.include "m88def.inc"
;.include "m16def.inc"
;.include "m162def.inc"
;.include "m168def.inc"
;.include "m328Pdef.inc"
.include "m640def.inc"

;			set the FirstBootStart fuse on these AVRs:
;.include "m32def.inc"
;.include "m64def.inc"
;.include "m644def.inc"
;.include "m128def.inc"
;.include "m1281def.inc"
;.include "m2561def.inc"


;			remove comment sign to exclude API-Call:
;			only on ATmega >= 8kB supported
;.equ	APICALL		= 0

;			remove comment sign to exclude Watchdog trigger:
;.equ   WDTRIGGER	= 0

;			remove comment sign to exclude CRC:
;.equ	CRC		= 0	

;			remove comment sign to exclude Verify:
;.equ	VERIFY		= 0

;-------------------------------------------------------------------------
;                               Port definitions
;						use D3-Tx and D2-Rx for Axon, USB
;						use E1-Tx and E0-Rx for Axon, UART0
;						use D1-Tx and D0-Rx for $50 Robot
;-------------------------------------------------------------------------
;			set both lines equal for inverted onewire mode:

.equ    STX_PORT        = PORTE
.equ    STX             = PE1

.equ    SRX_PORT        = PORTE
.equ    SRX             = PE0
;-------------------------------------------------------------------------
.include "fastload.inc"
;-------------------------------------------------------------------------
